Summary: Storage Instantiation Daemon (SID)
Name:    sid
Version: 0.0.5
Release: 5%{?dist}
License: GPLv2+
URL: http://sid-project.github.io
Source0: https://github.com/sid-project/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires: autoconf automake gperf gcc libtool
BuildRequires: make systemd-rpm-macros systemd-devel libudev-devel libuuid-devel libblkid-devel
BuildRequires: device-mapper-multipath-devel
Requires: systemd systemd-udev
Requires: %{name}-base-libs = %{version}-%{release} %{name}-log-libs = %{version}-%{release}
Requires: %{name}-resource-libs = %{version}-%{release} %{name}-tools = %{version}-%{release}

%description
Storage Instantiation Daemon (SID) aims to help with Linux storage device state tracking that
encompasses device layers, groups and whole stacks by monitoring progression of events. Based on
monitored states and further recorded information, it is able to trigger associated actions for
well-defined triggers, including activation and deactivation of devices and their layers in the stack.

%package base-libs
Summary: Libraries for Storage Instantiation Daemon (SID) base
License: GPLv2+

%description base-libs
This package contains shared libraries with low-level functionality needed for Storage Instantiation
Daemon (SID), its modules and related tools. Currently, it contains basic support for bitmaps,
buffering, IPC, hashing, lists, memory handling and other helper functions.

%package base-libs-devel
Summary: Development files for Storage Instantiation Daemon (SID) base
License: GPLv2+
Requires: %{name}-base-libs = %{version}-%{release}

%description base-libs-devel
This package contains development files for Storage Instantiation Daemon (SID) base libraries.

%package log-libs
Summary: Libraries for Storage Instantiation Daemon (SID) logging
License: GPLv2+

%description log-libs
This package contains shared libraries with logging support needed for Storage Instantiation daemon
(SID), its modules and related tools.

%package log-libs-devel
Summary: Development files for Storage Instantiation Daemon (SID) logging
License: GPLv2+
Requires: %{name}-log-libs = %{version}-%{release}

%description log-libs-devel
This package contains development files for Storage Instantiation Daemon (SID) logging libraries.

%package iface-libs
Summary: Libraries for Storage Instantiation Daemon (SID) interfaces
License: GPLv2+
Requires: %{name}-base-libs = %{version}-%{release}

%description iface-libs
This package contains shared libraries to support interfaces used in Storage Instantiation Daemon
(SID), its modules and related tools.

%package iface-libs-devel
Summary: Development files for Storage Instantiation Daemon (SID) interfaces
License: GPLv2+
Requires: %{name}-iface-libs = %{version}-%{release}

%description iface-libs-devel
This package contains development files for Storage Instantiation Daemon (SID) interface libraries.

%package resource-libs
Summary: Libraries for Storage Instantiation Daemon (SID) resources
License: GPLv2+
Requires: %{name}-base-libs = %{version}-%{release}
Requires: %{name}-log-libs = %{version}-%{release}
Requires: %{name}-iface-libs = %{version}-%{release}
Requires: systemd-libs

%description resource-libs
This package contains shared libraries to support high-level resources that represent hierarchical
units of reusable code used in Storage Instantiation Daemon (SID), its modules and related tools.
Currently, it contains support for aggregation, key-value store, module loading and registry, worker
process control, bridging SID core and udev and creating an instance of SID as a whole.

%package resource-libs-devel
Summary: Development files for Storage Instantiation Daemon (SID) resources
License: GPLv2+
Requires: %{name}-resource-libs = %{version}-%{release}

%description resource-libs-devel
This package contains development files for Storage Instantiation Daemon (SID) resource libraries.

%package tools
Summary: Storage Instantiation Daemon (SID) supporting tools
Requires: %{name}-base-libs = %{version}-%{release}
Requires: %{name}-log-libs = %{version}-%{release}
Requires: %{name}-iface-libs = %{version}-%{release}
Requires: systemd-udev

%description tools
This package contains tools to support Storage Instantiation Daemon (SID).

%package mod-dummies
Summary: Dummy block and type module for Storage Instantiation Daemon (SID)
Requires: %{name}-log-libs = %{version}-%{release}
Requires: %{name}-resource-libs = %{version}-%{release}

%description mod-dummies
This package contains dummy block and type modules for Storage Instantiation Daemon (SID). Their
only purpose is to test SID module functionality and hook execution.

%package mod-block-blkid
Summary: Blkid block module for Storage Instantiation Daemon (SID)
Requires: %{name}-log-libs = %{version}-%{release}
Requires: %{name}-resource-libs = %{version}-%{release}

%description mod-block-blkid
This package contains blkid block module for Storage Instantiation Daemon (SID).

%package mod-block-dm-mpath
Summary: Device-mapper multipath block module for Storage Instantiation Daemon (SID)
Requires: %{name}-log-libs = %{version}-%{release}
Requires: %{name}-resource-libs = %{version}-%{release}
Requires: device-mapper-multipath-libs

%description mod-block-dm-mpath
This package contains device-mapper multipath block module for Storage Instantiation Daemon (SID).

%package mod-type-dm
Summary: Device-mapper type module for Storage Instantiation Daemon (SID)
Requires: %{name}-log-libs = %{version}-%{release}
Requires: %{name}-resource-libs = %{version}-%{release}

%description mod-type-dm
This package contains device-mapper type module for Storage Instantiation Daemon (SID).

%prep
%autosetup -p1 -n sid-%{version}

%build
./autogen.sh
%configure
%make_build

%install
%make_install
rm -f %{buildroot}/%{_libdir}/sid/*.{a,la}
rm -f %{buildroot}/%{_libdir}/sid/modules/ucmd/block/*.{a,la}
rm -f %{buildroot}/%{_libdir}/sid/modules/ucmd/type/*.{a,la}

%post
%systemd_post sid.socket sid.service

%preun
%systemd_preun sid.service sid.socket

%postun
%systemd_postun sid.service sid.socket

%files
%license COPYING
%doc README.md
%config(noreplace) %{_sysconfdir}/sysconfig/sid.sysconfig
%{_udevrulesdir}/00-sid.rules
%{_unitdir}/sid.socket
%{_unitdir}/sid.service
%{_sbindir}/sid
%{_mandir}/man8/sid.8.gz

%files base-libs
%doc README.md
%dir %{_libdir}/sid
%{_libdir}/sid/libsidbase.so.*

%files base-libs-devel
%doc README.md
%dir %{_libdir}/sid
%{_libdir}/sid/libsidbase.so
%dir %{_includedir}/sid
%{_includedir}/sid/config.h
%dir %{_includedir}/sid/base
%{_includedir}/sid/base/bitmap.h
%{_includedir}/sid/base/buffer-common.h
%{_includedir}/sid/base/buffer.h
%{_includedir}/sid/base/common.h
%{_includedir}/sid/base/comms.h
%{_includedir}/sid/base/list.h
%{_includedir}/sid/base/mem.h
%{_includedir}/sid/base/util.h

%files log-libs
%doc README.md
%dir %{_libdir}/sid
%{_libdir}/sid/libsidlog.so.*

%files log-libs-devel
%doc README.md
%dir %{_libdir}/sid
%{_libdir}/sid/libsidlog.so
%dir %{_includedir}/sid
%dir %{_includedir}/sid/log
%{_includedir}/sid/log/log.h


%files iface-libs
%doc README.md
%dir %{_libdir}/sid
%{_libdir}/sid/libsidiface_servicelink.so.*
%{_libdir}/sid/libsidiface_usid.so.*

%files iface-libs-devel
%doc README.md
%dir %{_libdir}/sid
%{_libdir}/sid/libsidiface_servicelink.so
%{_libdir}/sid/libsidiface_usid.so
%dir %{_includedir}/sid
%dir %{_includedir}/sid/iface
%{_includedir}/sid/iface/service-link.h
%{_includedir}/sid/iface/usid.h

%files resource-libs
%doc README.md
%dir %{_libdir}/sid
%{_libdir}/sid/libsidresource.so.*

%files resource-libs-devel
%doc README.md
%dir %{_libdir}/sid
%{_libdir}/sid/libsidresource.so
%dir %{_includedir}/sid
%dir %{_includedir}/sid/resource
%{_includedir}/sid/resource/kv-store.h
%{_includedir}/sid/resource/module-registry.h
%{_includedir}/sid/resource/module.h
%{_includedir}/sid/resource/resource-type-regs.h
%{_includedir}/sid/resource/resource.h
%{_includedir}/sid/resource/ucmd-module.h
%{_includedir}/sid/resource/worker-control.h

%files tools
%doc README.md
%{_sbindir}/sidctl
%{_udevrulesdir}/../usid

%files mod-dummies
%doc README.md
%dir %{_libdir}/sid
%dir %{_libdir}/sid/modules/
%dir %{_libdir}/sid/modules/ucmd
%dir %{_libdir}/sid/modules/ucmd/block
%dir %{_libdir}/sid/modules/ucmd/type
%{_libdir}/sid/modules/ucmd/block/dummy_block.so
%{_libdir}/sid/modules/ucmd/type/dummy_type.so

%files mod-block-blkid
%doc README.md
%dir %{_libdir}/sid
%dir %{_libdir}/sid/modules
%dir %{_libdir}/sid/modules/ucmd
%dir %{_libdir}/sid/modules/ucmd/block
%{_libdir}/sid/modules/ucmd/block/blkid.so

%files mod-block-dm-mpath
%doc README.md
%dir %{_libdir}/sid
%dir %{_libdir}/sid/modules
%dir %{_libdir}/sid/modules/ucmd
%dir %{_libdir}/sid/modules/ucmd/block
%{_libdir}/sid/modules/ucmd/block/dm_mpath.so

%files mod-type-dm
%doc README.md
%dir %{_libdir}/sid
%dir %{_libdir}/sid/modules
%dir %{_libdir}/sid/modules/ucmd
%dir %{_libdir}/sid/modules/ucmd/type
%dir %{_libdir}/sid/modules/ucmd/type/dm
%{_libdir}/sid/modules/ucmd/type/dm.so

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.0.5-5
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 23 2023 kianli <kianli@tencent.com> - 0.0.5-4
- Rebuilt for device-mapper-multipath 0.9.5

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.0.5-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.0.5-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 30 2023 Shuo Wang <abushwang@tencent.com> - 0.0.5-1
- initial build
